//panels01

var gameloop;
var population;
var energy;
var gameyear = 2050;
var cutscene_on;

var pop_galactic;	// master population of everyone in all systems

bmap button_ul = <move_buttons_direct.pcx>,0,0,32,32;
bmap button_uc = <move_buttons_direct.pcx>,32,0,32,32;
bmap button_ur = <move_buttons_direct.pcx>,64,0,32,32;
bmap button_cl = <move_buttons_direct.pcx>,0,32,32,32;
bmap button_cr = <move_buttons_direct.pcx>,64,32,32,32;
bmap button_dl = <move_buttons_direct.pcx>,0,64,32,32;
bmap button_dc = <move_buttons_direct.pcx>,32,64,32,32;
bmap button_dr = <move_buttons_direct.pcx>,64,64,32,32;

//bmap button_map_ul = <move_buttons_map.pcx>,0,0,32,32;
//bmap button_map_uc = <move_buttons_map.pcx>,32,0,32,32;
//bmap button_map_ur = <move_buttons_map.pcx>,64,0,32,32;
//bmap button_map_cl = <move_buttons_map.pcx>,0,32,32,32;
//bmap button_map_cr = <move_buttons_map.pcx>,64,32,32,32;
//bmap button_map_dl = <move_buttons_map.pcx>,0,64,32,32;
//bmap button_map_dc = <move_buttons_map.pcx>,32,64,32,32;
//bmap button_map_dr = <move_buttons_map.pcx>,64,64,32,32;

//bmap builder_beam_spr = <builder_beam.tga>;
//bmap builder_beam2_spr = <builder_beam2.tga>;
//string builder_beam_str = <builder_beam2.tga>;
//

var context_location;
function init_panels();

function build_orbital_here();
function build_colony_here();

//panel variables

var planet_population_var;
var planet_energyoutput_var;

font digit_font = <bkfont.pcx>,12,16;
//font screen_font = <bkfont2.pcx>,12,16;
//font readout_font = <bkfont3.pcx>,12,16;

font small_font = <ackfont.pcx>,6,9;
bmap panel_background_pcx = <panel_background.pcx>;
bmap panel_colors_pcx = <colors01.pcx>;

string temp_colors_pcx = <colors01.pcx>;		//default colors/flag
string player_colors_pcx = <colors01.pcx>;
string drakkan_colors_pcx = <colors02.pcx>;
string probe_mdl = <probe1.mdl>;
string station_base1_mdl = <station_base.mdl>;

entity* probe_ent;

string system_name_txt[20];
string planet_name_txt[20];
string description_holder;
string body_name[20];
function terran_md();



entity* terran_md_ent;
entity* frozen_sm_ent;
entity* barren_md_ent;
entity* barren_lg_ent;
entity* gas_md_ent;
entity* gas_lg_ent;
entity* gas_giant_ent;
entity* gas_ringed_ent;
entity* molten_sm_ent;
entity* molten_md_ent;


bmap build_probe_button = <build_buttons2.pcx>,0,0,64,64;
bmap build_orbital_button = <build_buttons2.pcx>,0,64,64,64;
bmap build_colony_button = <build_buttons2.pcx>,64,0,64,64;

bmap build_station_button = <build_buttons2.pcx>,0,0,64,64;
bmap options_move_button = <options_buttons.pcx>,0,0,64,64;

function move_unit_ul2;
function move_unit_uc2;
function move_unit_ur2;
function move_unit_cr2;
function move_unit_cl2;
function move_unit_dl2;
function move_unit_dr2;
function move_unit_dc2;

function engine_loop();
function engine_effect_probe();

function projectile_explodes();

bmap screen_map, <overlay.bmp>;

var move_temp[3];

//string select_ring_ent = <select_ring.tga>;
string move_ring_spr = <move_ring.tga>;

function select_object();

var number_of_characters;
var text_var;

///////////////////////////////////////////////////////////////////////////////

sky star_cube
{
  type = <skycube+6.tga>;
  layer = 2;
  scale_x = 0.25;
  speed_u = 0.25;
 	//scene = on;
 	flags = scene,overlay,visible;
  
}



action player_colors_func()
{
	player_colors_ent = me;
	var colors_offset[3];
//	my.pan = 90;
	my.scale_x = 0.1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.invisible = on;
	colors_offset.x = 5;
	colors_offset.z = 50;
	wait(1);
	while(me != null)
	{
		you = null;
		you = ptr_for_handle(my.parent_handle);
		if(you != null)
		{
			my.x = your.skill2 + colors_offset.x;
			my.y = your.skill3;
			my.z = your.skill4 + colors_offset.z;
			if(your.invisible == on)
			{
				my.invisible = on;
			}
			if(your.invisible == off)
			{
				my.invisible = off;
			}
			if(your.skill69 == 0)
			{
				my.invisible = on;
				
			}
			if(your.skill69 == 1)		//occupied by team one
			{
				ent_morph(me,player_colors_pcx);
				my.invisible = off;
			}
			if(your.skill69 == 2)
			{
				ent_morph(me,drakkan_colors_pcx);
				my.invisible = off;
				
			}
			if(cutscene_on == 1)
			{
				my.invisible = on;
			}
				
			}
			if(you == null)
			{
				ent_remove(me);
			}
			
		wait(1);
	}
}

string move_input[30];

function move_me_grid_id(you)
{

	while(1)
	{
		
		wait(1);
	}
	
	}

panel move_panel
{
	layer = 21;
	pos_x = 1000;
	pos_y =480;
	button = 0,0, button_ul,button_ul,button_ul,move_unit_ul2,null,null;
	button = 32,0, button_uc,button_uc,button_uc,move_unit_uc2,null,null;
	button = 64,0, button_ur,button_ur,button_ur,move_unit_ur2,null,null;
	button = 0,32, button_cl,button_cl,button_cl,move_unit_cl2,null,null;
	button = 64,32, button_cr,button_cr,button_cr,move_unit_cr2,null,null;
	button = 0,64, button_dl,button_dl,button_dl,move_unit_dl2,null,null;
	button = 32,64, button_dc,button_dc,button_dc,move_unit_dc2,null,null;
	button = 64,64, button_dr,button_dr,button_dr,move_unit_dr2,null,null;
}

//panel map_move_panel
//{
//	layer = 21;
//	pos_x = 1000;
//	pos_y = 863;
//	button = 0,0, button_map_ul,button_map_ul,button_map_ul,move_map_ul,null,null;
//	button = 32,0, button_map_uc,button_map_uc,button_map_uc,move_map_uc,null,null;
//	button = 64,0, button_map_ur,button_map_ur,button_map_ur,move_map_ur,null,null;
//	button = 0,32, button_map_cl,button_map_cl,button_map_cl,move_map_cl,null,null;
//	button = 64,32, button_map_cr,button_map_cr,button_map_cr,move_map_cr,null,null;
//	button = 0,64, button_map_dl,button_map_dl,button_map_dl,move_map_dl,null,null;
//	button = 32,64, button_map_dc,button_map_dc,button_map_dc,move_map_dc,null,null;
//	button = 64,64, button_map_dr,button_map_dr,button_map_dr,move_map_dr,null,null;
//	digits = 35,2,3,digit_font,1,context_location;
////	
////	flags = visible;
//	
//}
////function move_selected
//{
//	
//	move_panel.visible = on;
//}

//
//panel move_button
//{
//	pos_x = 1000;
//	pos_y = 400;
//	digits = 22,2,3,digit_font,1,context_location;
//	button = 0,0, options_move_button,options_move_button,options_move_button,move_selected,null,null;
//}

action move_ring 
{
	my.invisible = on;
	my.passable = on;
	my.oriented = on;
	my.bright = on;
	my.near = on;
	my.scale_x = your.scale_x;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	wait(1);
	while(my != null)
	{
			my.pan += 0.5 * time;
		
		you = null;
		you = ptr_for_handle(my.parent_handle);
		if(you != null) 
		{
			vec_set(my.x,you.x);
			my.z = your.z - 120;
			my.tilt = you.tilt + 90;
			my.roll = you.roll;
			if(your.flag1 == 1)
			{
				my.invisible = off;
				vec_set(my.x,you.x);
				my.z = your.z - 100 * your.scale_x;
				my.tilt = you.tilt + 90;
				my.roll = you.roll;
				//my.pan += 0.5 * time;
			}
			if(your.flag1 == 0 || your.flag2 == 0)
			{
				my.invisible = on;
			}
		}
		if(you == null)
		{
			ent_remove(me);
		}
		wait(1);
	}

}

action select_ring 
{
	my.invisible = on;
	my.passable = on;
	my.oriented = on;
	my.bright = on;
	my.near = on;
	my.scale_x = your.scale_x;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	
	wait(1);
	while(my != null)
	{
		you = null;
		you = ptr_for_handle(my.parent_handle);
		if(you != null) 
		{
			vec_set(my.x,you.x);
			my.z = your.z - 120;
			my.tilt = you.tilt + 90;
			my.roll = you.roll;
			my.pan += 5 * time;
			while(your.flag1 == 1)
			{
				my.invisible = off;
				vec_set(my.x,you.x);
				my.z = your.z - 100 * your.scale_x;
				my.tilt = you.tilt + 90;
				my.roll = you.roll;
				my.pan += 5 * time;
				wait(1);
			}
			while(your.flag1 == 0)
			{
				my.invisible = on;
				wait(1);
				
			}
		}

		if(you == null) {ent_remove(me);}	
		wait(1);
	}
	}
	


function options_display(me)
{
	while(my.selected == on)
	{
		move_panel.visible = on;
		wait(1);	
	}
	move_panel.visible = off;
}



function probe_events()
{
	
	
//	temp_id = my.grid_id;
//	temp_ptr = ptr_for_handle(plate_entities[temp_id]);
	if(EVENT_TYPE == event_touch)
	{
			
		//turnon_lpanel(me);
		//build_options_var = 1;
		//build_options_display(me);	
		//population_display(me);
		//change_planet_text(me);
		//context_location = my.grid_id;
		
	}

	if(EVENT_TYPE == event_release)
	{
		//build_options_var = 0;

		
	}
	if (EVENT_TYPE == event_rightclick)
	{
		planet_cam_on_me(me);
		options_display(me);
		select_object();	
	}
	if(EVENT_TYPE == EVENT_Scan)
	{
//		if(you == camera_ent || you == player)
//		{
//			diag("\nyoure player or camera");
//			your.invisible == on;
//		}
		if(you == probe_ent)
		{
			diag("\nyoure the probe");
		}
//		if(your.flag4 == 1 || your.skill33 > result)
//		{
//			diag("\nyou are the homeworld");
//			your.transparent = on;
//			your.alpha = 0;
//		}
//		if(your.skill33 == 1000)
//		{
//			diag("\nyou are the homeworld");
//		}

	}
	if(EVENT_TYPE == EVENT_DETECT)
	{

		set_detect(you);

			
	}
	if(EVENT_TYPE == EVENT_SONAR)
	{
	}
	if(EVENT_TYPE == EVENT_IMPACT)
	{
		my.skill30 -= 2;
	}
}
//define mode, skill80;
//define range, skill81;
//define speed,skill82;
//define agility,skill83;

function destroy_me(me)
{
	
	ent_remove(me);
}

function probe_destroy()
{
	probe_ent.skill30 = 0;
}

function probe_func()
{
	probe_ent = me;
	var colors_pos[3];
	var my_distance;
	
	my.scale_x = 0.05;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	c_setminmax(me);
	my.parent_handle = handle(you);
	my.skill1 = your.skill1;
	my.skill2 = my.x;
	my.skill3 = my.y;
	my.skill4 = my.z;
	
	
	my.skill30 = 100;			//my health
	my.skill31 = 5;			//my speed
	my.skill32 = 0.01;			//my agility
	my.skill33 = 200;			// my scan range
	my.skill34 = 10;			//my fuel range
	my.skill35 = 0;			//my.target_x
	my.skill36 = 0;			//my.angle_pan
	my.skill37 = 0;			//my.unit_scan
	my.skill38 = 1;			//i'm a probe
	my.skill39 = 200;			//my comm range
	my.flag1 = 0;				//selected y/n
	my.flag2 = 0;				//detected y/n
	my.flag6 = 0;				//moving y/n
	
	my.skill69 = 1;			//my team/colors
	
	my.enable_impact = on;

	my.enable_entity = on;
	my.enable_touch = on;
	my.enable_release = on;
	my.enable_rightclick = on;
	my.enable_scan = on;
	my.enable_detect = on;
	my.enable_sonar = on;
	my.event = probe_events;
	
	colors_pos.x = my.skill2;
	colors_pos.y = my.skill3;
	colors_pos.z = my.skill4 + 1;
	wait(1);
	you = ent_create(player_colors_pcx, colors_pos, player_colors_func);		//my colors
	you.parent_handle = handle(me);
	wait(1);
	you = ent_create(move_ring_spr,my.x,move_ring);									//my move ring
	you.parent_handle = handle(me);
	
	var scan_temp[3];
	var scan_source[3];
	var detect_temp;
	var engine_temp_1[3];
	var engine_temp_2[3];
	var engine_temp_3[3];
	var start_point[3];
	var move_point[3];
	var temp_ang[3];
	var my_distance_from;
	
	start_point.x = my.x;
	start_point.y = my.y;
	start_point.z = my.z;
	
	while(my.flag1 != 1)
		{
			wait(1);					//wait until i'm selected and my direction is not set
		}
	while(my.flag6 != 1)
		{
			wait(1);
		}
	//while(me != null)
	while(my.skill30 > 0)
		{
			
			if(my.detected == off)
			{
				my.invisible = on;
			}
			my.skill2 = my.x;
			my.skill3 = my.y;
			my.skill4 = my.z;
			
			scan_temp.x = 360;
			scan_temp.y = 360;
			scan_temp.z = my.skill33;
			
			scan_source.x = my.x;
			scan_source.y = my.y;
			scan_source.z = my.z;
				
			scan_entity(scan_source,scan_temp);
			
			vec_for_vertex(engine_temp_1, me,362);
			vec_for_vertex(engine_temp_2, me,298);			
			vec_for_vertex(engine_temp_3, me,330);
			
			my.skill41 = my.skill31 * time;
			
			if(my_distance < my.skill34)
			{
				move_mode = IGNORE_ME + IGNORE_PASSABLE + GLIDE;
				move_friction = my.skill32;
				ent_move(my.skill41,nullvector);
				//ent_playsound (my, engine1_wav, 40);
				if(my.detected == on)
				{
					effect(engine_effect_probe, 2,engine_temp_1, normal);
					effect(engine_effect_probe, 2,engine_temp_2, normal);
					effect(engine_effect_probe, 2,engine_temp_3, normal);
					
				}
			}
			my_distance += my.skill32 * time;					//my_distance = my agility(fuel consumption)
			
			if(my_distance > my.skill34)
			{
				my.skill41 = (my.skill31 * 0.01) * time;		//but still i have spacial drift
				
				ent_move(my.skill41,nullvector);
			}
						wait(1);
		}
		
		destroy_me(me);	
}

on_y = probe_destroy();



function build_probe()
{
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(your.flag1 == 1 && energy > 850)
		{
			var create_point[3];
			energy -= 850;
			create_point.x = your.skill2 + 50;
			create_point.y = your.skill3;
			create_point.z = your.skill4;
			
			ent_create(probe_mdl,create_point,probe_func);
			menu01_play_select_snd();	
		}
		else
		{
			
		}
 		you = ent_next (you); // get next entity
 			
 	}

}

function beam_loop()
{

    	my.alpha -= 8 *time;
			

    	IF(My.alpha < 0) { my.alpha = 0; my.lifespan = 0; }

}


//function builder_beam()
//{
//	my.blue = 128;
//   my.green = 128;
//   my.red = 128;
//   my.bmap = builder_beam_spr; //the effect bitmap
//   my.vel_x = random( 0.5 ) - 0.250 ;
//   my.vel_y = random( 0.5 ) - 0.250 ;
//   my.vel_z = random( 0.5 );
//   my.oriented = on;
//   //my.size = 20;
//   my.alpha = 50;
//   my.gravity = off ;
//   my.streak = off;
//   my.flare = on;
//   my.bright = on;
//   my.beam = on;
//   my.move = on;
//   my.transparent = on;
//   my.function = beam_loop;
//	
//}

//string laser2_mdl = <laser2.mdl>;

function destroy_bullet()
{
    wait (1);
    //snd_play (explo1_wav, 30, 0);
    ent_remove (my);
}

function move_bullet1()
{
    var bullet_speed[3];
    var facing_vector[3];
    my.passable = on;
    my.scale_x = 0.1;
    my.scale_y = my.scale_x;
    my.scale_z = my.scale_x;
    my.enable_impact = on;
    my.enable_entity = on;
    my.event = destroy_bullet;
   // my.oriented = on;
    //my.pan = you.pan;
    bullet_speed.x = 50 * time;
    bullet_speed.y = 0;
    bullet_speed.z = 0;
    my.ambient = 100;
    my.bright = on;
    my.light = on;
    my.red = 50;
    my.green = 255;
    my.blue = 50;

    while (my != null) // as long as the bullet exists
    {
       if (you != null)
       {
//       	ray_size = 1;
//      	effect (attach_rays, 1, sword_vertex, normal);
//      	while (ray_size > 0)
//      {
//          vec_for_normal (temp_left, my, 235);
//          vec_normalize (temp_left, ray_size);
//          vec_add (sword_vertex, temp_left); 
//          effect (attach_rays, 1, sword_vertex, normal);
//          ray_size -= 0.01;
//      }S
          if(vec_dist (my.x, you.x) > 50)
          {
             my.passable = off;
          } 
       } 
       move_mode = ignore_you + ignore_passable;
       ent_move (bullet_speed, nullvector);
       wait (1);
    }
}



//function builder_beam_beam(me)
//{
//	var facing_vector[3];
//	var aiming_vector[3];
//    proc_kill(4);
//	
//	vec_for_bone(aiming_vector,me,"weapon1");
//    
//    //while ((key_space == on) || (mouse_left == on)) {wait (1);} // wait until the player releases the keys
//    //snd_play (fire2_wav, 40, 0);
//    //vec_sub (facing_vector, my.x);
//    //vec_to_angle(facing_vector,my.x);
//    //temp.x += 70; // the laser is generated in front of the ship
//    //ent_create (builder_beam_str, aiming_vector, move_bullet1);
//    //players_ammo -= 1;
//    
//    while (1)
//   {
//      wait (1);
//   }
//}
//
//

function bob_func3()
{
	var bone_vector3[3];
	var facing_vector[3];
	
	my.scale_x = 0.1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	
	while(you!=null)
	{
		vec_for_bone(bone_vector3,you,"joint4");
		
		vec_for_bone(facing_vector,you,"joint1");
		
		//vec_set(facing_vector,your.x); 
  		vec_sub(facing_vector,my.x);
  		vec_to_angle(my.pan,facing_vector);
		
		vec_set(my.x,bone_vector3);

		
		wait(1);
	}
	ent_remove(me);
	
}

function bob_func2()
{
	var bone_vector2[3];
	var facing_vector[3];
	var weapon_point1[3];
	my.scale_x = 0.1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	while(you!=null)
	{
		vec_for_bone(bone_vector2,you,"joint3");
		
		vec_for_bone(facing_vector,you,"joint1");
		vec_for_bone(weapon_point1,me,"weapon1");
		//vec_set(facing_vector,your.x); 
  		vec_sub(facing_vector,my.x);
  		vec_to_angle(my.pan,facing_vector); 		
	
		vec_set(my.x,bone_vector2);
		//effect(builder_beam,2,weapon_point1,nullvector);
		//builder_beam_beam(me);
		
		
		wait(1);
	}
	ent_remove(me);
	
}

function bob_func1()
{
	var bone_vector1[3];
	var facing_vector[3];
	
	my.scale_x = 0.1;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	
	while(you!=null)
	{
		vec_for_bone(bone_vector1,you,"joint2");
		vec_for_bone(facing_vector,you,"joint1");
		
  		vec_sub(facing_vector,my.x);
  		vec_to_angle(my.pan,facing_vector);
		
		vec_set(my.x,bone_vector1);

		
		wait(1);
	}
	ent_remove(me);
}

entity* builder;

function remove_builder(me)
{
	ent_remove(me);
}

function builders_func()
{
	var bone_vector1[3];
	var bone_vector2[3];
	var bone_vector3[3];
	var building_vector[3];
	var weapon_point1[3];
	builder = me;
	my.scale_x = your.scale_x + 0.5;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	
	vec_for_bone(bone_vector1,me,"joint2");
	vec_for_bone(bone_vector2,me,"joint3");
	vec_for_bone(bone_vector3,me,"joint4");
	
	you = ent_create(space_bob_mdl, bone_vector1, bob_func1);
	wait(1);
	you = ent_create(space_bob_mdl, bone_vector2, bob_func2);
	wait(1);
	you = ent_create(space_bob_mdl, bone_vector3, bob_func3);
	wait(1);
	while(1)
	{	
		my.pan += 5 * time;
		wait(1);
	}
	
}

function station_func()
{
	var build_time_tracker;
	my.skill1 = your.skill1;
	my.scale_x = 0.25;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.skill99 = 100;
	my.transparent = on;
	my.alpha = 0;
	you = ent_create(space_bldr_mdl, my.x, builders_func);
	//increase_scan();
	while(build_time_tracker < my.skill99)
		{
			build_time_tracker += 1 * time;
			my.alpha += 1 * time;
			wait(1);
		}
	ent_remove(you);
	while(1)
	{
		my.pan -= 1 * time;
		
		wait(1);
	}
}

function build_orbital()
{
	var station_vec[3];
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(your.flag1 == 1)
		{
			build_orbital_here(you);
			//mouse_map = build_orbital_button;
			
		}
 		you = ent_next (you); // get next entity
 			
 	}

}

function build_colony()
{
	var station_vec[3];
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(your.flag1 == 1)
		{
			build_colony_here(you);
			//mouse_map = build_colony_button;			
		}
 		you = ent_next (you); // get next entity
 			
 	}

}

text body_name_txt
{
	strings = 1;
	string = body_name;
}

text help_01
{
	font = digit_font;
	strings = 1;
	string = "RIGHT CLICK ON PLANETS TO SEE THEIR OPTIONS";
	//flags = visible;
}

text help_02
{
	font = digit_font;
	
	strings = 1;
	string = "RIGHT CLICK TWICE ON PROBES TO LAUNCH THEM";
	//flags = visible;
}

text help_03
{
	font = digit_font;
	
	strings = 1;
	string = "MOUSE CONTROLS THE MAP ORIENTATION";
//	flags = visible;
}

text help_04
{
	font = digit_font;
	
	strings = 1;
	string = "BLUE ARROW BUTTONS MOVES PROBE";
	//flags = visible;
}

text help_05
{
	font = digit_font;
	
	layer = 5;
	strings = 1;
	string = "COLONIZE AS MANY PLANETS AS YOU CAN";
	//flags = visible;
}

text help_06
{
	font = digit_font;
	
	layer = 5;
	strings = 1;
	string = "THE Z KEY ZOOMS THE CAMERA VIEW";
	//flags = visible;
}

text help_07
{
	font = digit_font;
	
	layer = 5;
	strings = 1;
	string = "ESC ACTIVATES SAVE/LOAD/EXIT MENU";
	//flags = visible;
}


text name_index		//system names
{
	strings = 85;
	string = "UNKNOWN","EARTH","DRAKKAN","SHAZZA","ALOUS","ABYLA","ACIS","ACROPOLIS","ACTAEON","AIDOS","ALECTO","ARCTURUS","BAUCIS","BOREAS","BROMIUS","CADMUS",	//17
	"CALYDON","CALLISTO","CALYPSO","CHAOS","ECHO","ERATO","HADES","HARMONIA","HARPIES","HEBRUS","HECUBA","HELIADES","HEARTH",													//30
	"FALCONUS","TAURUS","TANTALUS","KRATOS","MORPHEUS","ARGUS","VALKYRIES","ODINUS","THORIUS","FREYAS","HECTORIUS","TALUS", "TARTARUS",
	"TEMPE","THALIA","URDU","VOLSUNG","STRIFE","ARGONAUT","PACTOLUS","PANDORA","PERGAMOS","POMONA","MINOS","MEGARA","MAGNA","LUCIANA",
	"MENTORRA","MEMNON","ASPACIA","BALDERSTONE","RIMINI","PHOEBUS","PERICLES","NOGGS","NISUS","MODISH","HODGE","KEHAMA","IDOMENEUS","LACHESIS",
	"LEAR","LAMBRO","LAMIA","LAPUTA","LAS CASAS","LAUNCE","PAWKINS","OZ","OTHELLO","MAMTE","MYSHKIN","MODRED","MOMMUR","MIRANDA"; 
}


text planet_name_index		// planet names
{
	strings = 80;
	string = "UNKNOWN",
	"MERCURY","VENUS","EARTH","MARS","JUPITER","SATURN","NEPTUNE","URANUS","PLUTO","CHARON",//EARTHS SYSTEM
	"DRAKKAN","ZANISTUS", "FLORA","CANUBRIA","LESSIX","NALBA",																	//DRAKKAN SYSTEM
	"ABARIA","AMBERSON","BALTHAZ","MAGII","FERRIX","PORRIX","DONATELLO","ESMEREL","PELLEAS","ETTERRE"
	"DARIUS","ABARIUS","ALCEMNA","GELERT","FROME","GANEM","HARPOCRATES","HAVELOCK",
	"MIDAS","MIDGARD","LOTHLORIEN","TRISTRAM","THURIO",	//40
	"X-1","X-2","M95-1","THIRTEEN","WESTLOCK","TUTT","RUBRICK","SANGRALL","SAPHO","SANGER","THESEUS","THISBE","PYRAMUS",
	"MALEBOLGE","LOCKIT","LEDA","LECOQ","HIPPOCRENE","HIPPOCAMPUS","JAFFIER","JARNDYCE","KREIMHILD","KRISHNA","LAODAMIA","LARSEN",
	"PALINODE","OSIRIS","NAUNA","IAGO","PEAKE","PEDRO","TEMPEST","SHIBBOLETH","SEDLEY","Q-36","Q-39","BUGS","LANDAU","SEMELE","NEW YOSEMITE";
	
}

text moon_name_index
{
	strings = 59;
	string = "UNKNOWN",//IF 0
	"MOON",				// earth
	"DEIMOS","PHOBOS",	//mars 2
	"METIS","ADRASTEA","AMALTHEA","THEBE","IO","EUROPA","GANYMEDE","CALLISTO","HIMALIA","LYSITHEA","ELARA","ANANKE","CARME",	//jupiter 13
	"PAN","ATLAS","PROMETHEUS","PANDORA","EPIMETHEUS","JANUS","MIMAS","ENCELADUS","TETHYS","TELESTO","CALYPSO","DIONE","HELENE","RHEA","TITAN","HYPERION","IAPETUS",	//saturn 17
	"CORDELIA","OPHELIA","BIANCA","CRESSIDA","DESDEMONA","JULIET","PORTIA","ROSALIND","BELINDA","PUCK","MIRANDA","ARIEL","UMBRIEL","TITANIA","OBERON","CALIBAN","SYCORAX",	//uranus 17
	"NAIAD","THALASSA","DESPINA","GALATEA","LARISSA","PROTEUS","TRITON","NEREID";	//neptune 8
	
}

text name_display
{
	font = digit_font;
	//pos_x = 1120;
	//pos_y = 270;
	strings = 1;
	string = system_name_txt;
	flags = visible;
}

text planet_name_display
{
	font = digit_font;
	strings = 1;
	string = planet_name_txt;
	flags = visible;
	
}

text sector_txt
{
	//pos_x = 0;
	//pos_y = 9;
	layer = 5;
	font = digit_font;
	string = "SECTOR";
	flags = visible;
	
}

//text description_string_txt
//{
//	layer = 5;
//	font = digit_font;
//	string = description_holder;
//	flags = visible;
//}
//
//text developing_txt
//{
//	layer = 5;
//	font = digit_font;
//	string = "DEVELOPING";
//	flags = visible;
//}


//text description_txt
//{
//	layer = 5;
//	font = digit_font;
//	string = "DESCRIPTION";
//	flags = visible;
//}
text name1_txt
{
	font = digit_font;
	string = "EARTH";
}

text planet_txt
{
	layer = 5;
	font = digit_font;
	string = "PLANET";
	flags = visible;
	
}
//
//text homeworld_display
//{
//	font digit_font;
//	layer 5;
//	string = "HOMEWORLD";
//	//flags = visible;
//	
//}

text planet_population_txt
{
	layer = 5;
	font = digit_font;
	strings = 2;
	string = "POPULATION","ENERGY OUTPUT";
	flags = visible;
}

panel planet_population_pan
{
	digits = 160,0,5,digit_font,1,planet_population_var;
	digits = 160,15,5,digit_font,1,planet_energyoutput_var;
	
	flags = overlay, refresh;
}

//panel planet_energyoutput_pan
//{
//	digits = 160,15,5,digit_font,1,planet_energyoutput_var;
//	flags = overlay, refresh;
//}

function draw_red_line(x1,y1,x2,y2)
{

	while(1)
	{
	
	draw_line(vector(x1,y1,0),NULL,100); // move to first corner   
  	draw_line(vector(x2,y1,0),vector(0,0,255),100);
  	draw_line(vector(x2,y2,0),vector(0,0,255),100);   
  	
  	wait(1);
  	}
}


//set panel variables
function set_panel_variables()
{
	mouse_mode = 1;
	init_panels();
	screen_size_xpan = screen_size.x-1;
	screen_size_ypan = screen_size.y-1;
	pan_x4 = screen_size.x/4;
	pan_x2 = screen_size.x/2;
	pan_y4 = screen_size.y/4;
	pan_y2 = screen_size.y/2;
	pan_x0 = screen_size_xpan - pan_x4;
	pan_y0 = screen_size_ypan - pan_y4;
	
	//draw_red_line(pan_x4,0,pan_x4,screen_size_ypan);
	draw_red_line(pan_x0,0,pan_x0,screen_size_ypan);
	//draw_red_line(0,pan_y2,pan_x0,pan_y2);
	//draw_red_line(0,pan_y4,pan_x4,pan_y4);
	draw_red_line(pan_x0,pan_y4,screen_size_xpan,pan_y4);
	
	//	set_name_display(pan_x0,0);
}



function draw_red_rect(x1,y1,x2,y2)
{  
	while(1)
  {   
   draw_line(vector(x1,y1,0),NULL,100); // move to first corner   
  	draw_line(vector(x2,y1,0),vector(0,0,255),100);   
  	draw_line(vector(x2,y2,0),vector(0,0,130),100);   
  	draw_line(vector(x1,y2,0),vector(0,0,255),100);   
  	draw_line(vector(x1,y1,0),vector(0,0,130),100);
  	wait(1);
  	}
  	}
  
function draw_green_rect(x1,y1,x2,y2)
{  
	while(key_shiftl == 1)
  {   
   draw_line(vector(x1,y1,0),NULL,100); // move to first corner   
  	draw_line(vector(x2,y1,0),vector(0,255,0),100);   
  	draw_line(vector(x2,y2,0),vector(0,255,0),100);   
  	draw_line(vector(x1,y2,0),vector(0,255,0),100);   
  	draw_line(vector(x1,y1,0),vector(0,130,0),100);
  	wait(1);
  	}
  	}
 
bmap population_gameh_pcx = <icons_game.pcx>,0,0,32,32;
bmap energy_game_pcx = <icons_game.pcx>,32,0,32,32;
bmap game_year_pcx = <icons_game.pcx>,0,64,32,32;
  
  
panel turn_screen
{
	layer =1;
 	button = 0,0, game_year_pcx,game_year_pcx,game_year_pcx,null,null,null;
 	digits = 32,6,4,digit_font,1,gameyear;
 	button = 0,32,population_gameh_pcx,population_gameh_pcx,population_gameh_pcx,null,null,null;
 	digits = 32,36,5,digit_font,1,population;
 	button = 0,64,energy_game_pcx,energy_game_pcx,energy_game_pcx,null,null,null;
 	digits = 32,66,5,digit_font,1,energy;
 	
// 	digits = 0,45,3, digit_font,1,ship_location.x;
// 	digits = 60,45,3,digit_font,1,ship_location.y;
// 	digits = 120,45,3,digit_font,1,ship_location.z;
// 	digits = 40, 229,3, digit_font,1,current_tile_location.x;
// 	digits = 110,229,3, digit_font,1,current_tile_location.y;
// 	digits = 0,90,5,digit_font,1,player_wealth;
// 	digits = 0,110,5,digit_font,1,player_energy;
// 	digits = 0,130,5,digit_font,1,player_metals;
// 	//digits = 0,45,15,digit_font,1,my.skill1;
// 	bmap = panel_background_pcx;
 	//window = 0,0,256,128,panel_background_pcx,panel_width,panel_height;
 	
// 	digits = 200,0,4,digit_font,1,player.skill71;
// 	//digits = 120,0,4,digit_font,1,my_height;
 	//window = 200,0,40,20,compass_map,compass_pos.x,compass_pos.y;
 	flags =  overlay, refresh, visible;
}  

//panel player_colors
//{
//	layer = 1;
//	bmap = panel_colors_pcx;
//	//window = 0,0,64,32,panel_colors_pcx,64,32;
// 	flags =  overlay, refresh, visible;
//	
//}

panel system_screen
{
 	window = 0,0,256,128,panel_background_pcx,panel_width,panel_height;
 	flags =  overlay, refresh;	
}

panel context_pan
{
	bmap = panel_background_pcx;
	pos_x = 0;
	pos_y = 0;
	layer = 1;
	digits = 22,2,3,digit_font,1,context_location;
	//digits = 0,50,3,digit_font,1,system_planet_number;
//	button = 2, 2, b1_640_pcx, b2_640_pcx, b1_640_pcx, change_resolution, null, null; 
//	button = 2, 22, b1_800_pcx, b2_800_pcx, b1_800_pcx, change_resolution, null, null;
//	button = 2, 42, b1_1024_pcx, b2_1024_pcx, b1_1024_pcx, change_resolution, null, null;
	flags = overlay, refresh;
}

function show_menu()
{
	mouse_mode = 2;
	context_pan.pos_x = pointer.x;
	context_pan.pos_y = pointer.y;
	context_pan.visible = on;
	//context_name_display.pos_x = pointer.x;
	//context_name_display.pos_y = pointer.y;
	//context_name_display.visible = on;
}

function hide_menu()
{
	context_pan.visible = off;
	wait (1);
	//mouse_mode = 0; // hide the pointer too
}

//bmap build_probe_button = <build_buttons2.pcx>,0,0,64,64;
//bmap build_station = <build_buttons2.pcx>,0,0,64,64;


panel build_options_display_h_pan		//for homeworlds
{
	//pos_x = 1000;
	//pos_y = 500;
	//digits = 22,2,3,digit_font,1,context_location;
	
	button = 0,0, build_probe_button,build_probe_button,build_probe_button,build_probe,null,null;
	//button = 64,0, build_colony_button,build_colony_button,build_colony_button,build_colony,null,null;
	//button = 128,0,build_orbital_button,build_orbital_button,build_orbital_button,build_orbital,null,null;
	//flags = visible;
}

panel build_options_display_c_pan
{
	layer = 6;
	//pos_x = 1000;
	//pos_y = 500;
	//digits = 22,2,3,digit_font,1,context_location;
	
//	button = 0,0, build_probe_button,build_probe_button,build_probe_button,build_probe,null,null;
	button = 64,0, build_colony_button,build_colony_button,build_colony_button,build_colony,null,null;
//	button = 128,0,build_orbital_button,build_orbital_button,build_orbital_button,build_orbital,null,null;

}

panel build_options_display_e_pan
{
	pos_x = 1000;
	pos_y = 500;
	//digits = 22,2,3,digit_font,1,context_location;
	
	//button = 0,0, build_probe_button,build_probe_button,build_probe_button,build_probe,null,null;
	//button = 64,0, build_colony_button,build_colony_button,build_colony_button,build_colony,null,null;
	button = 128,0,build_orbital_button,build_orbital_button,build_orbital_button,build_orbital,null,null;

}

function init_help_loop
{
	loop:
	help_01.pos_x = 1;
	help_01.pos_y = screen_size.y - 20;
	
	help_01.visible = on;
	wait(180);
	help_01.visible = off;
	help_02.pos_x = 1;
	help_02.pos_y = screen_size.y - 20;
	
	help_02.visible = on;
	wait(180);
	help_02.visible = off;
	help_03.pos_x = 1;
	help_03.pos_y = screen_size.y - 20;
	
	help_03.visible = on;
	wait(180);
	help_03.visible = off;
	help_04.pos_x = 1;
	help_04.pos_y = screen_size.y - 20;
	
	help_04.visible = on;
	wait(180);
	help_04.visible = off;
	help_05.pos_x = 1;
	help_05.pos_y = screen_size.y - 20;
	
	help_05.visible = on;
	wait(180);
	help_05.visible = off;
	help_06.visible = on;
	help_06.pos_x = 1;
	help_06.pos_y = screen_size.y - 20;
	wait(180);
	help_06.visible = off;
	help_07.visible = on;
	help_07.pos_x = 1;
	help_07.pos_y = screen_size.y - 20;
	wait(180);
	help_07.visible = off;
	goto(loop);
	
}

function init_panels()
{
	//player_colors.pos_x = pan_x0 +100;
	//player_colors.pos_y = 2;
	
	turn_screen.pos_x = pan_x0 +1;
	turn_screen.pos_y = 2;
	
	system_screen.pos_x = pan_x0;
	system_screen.pos_y = 3;
	system_screen.visible = on;
	if(video_mode > 7)
	{
		system_screen.scale_x = 1.5;
	
	}
	
	
	name_display.pos_x = pan_x0 + 97;
	name_display.pos_y = pan_y4 - 130;
	
	sector_txt.pos_x = pan_x0 + 3;
	sector_txt.pos_y = pan_y4 -130;
	
	planet_txt.pos_x = pan_x0 + 3;
	planet_txt.pos_y = pan_y4 - 114;
	
	planet_name_display.pos_x = pan_x0 + 97;
	planet_name_display.pos_y = pan_y4 -114;
	
	planet_population_pan.pos_x = pan_x0 + 3;
	planet_population_pan.pos_y = pan_y4 - 97;
	
	planet_population_txt.pos_x = pan_x0 + 3;
	planet_population_txt.pos_y = pan_y4 - 97;
	
	planet_cam.pos_x = screen_size.x - 322;
	planet_cam.pos_y = pan_y4;
	
	build_options_display_c_pan.pos_x = pan_x0;
	build_options_display_c_pan.pos_y = pan_y4 - 64;
	
	build_options_display_h_pan.pos_x = pan_x0;
	build_options_display_h_pan.pos_y = pan_y4 - 64;
	
	build_options_display_e_pan.pos_x = pan_x0;
	build_options_display_e_pan.pos_y = pan_y4 - 64;
	
	init_help_loop();
}

	
function update_gameloop()
{
	var temp_population;
	var temp_energy;
	
	gameyear +=0.001;
	
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(your.skill69 == 1)
		{
			temp_energy = your.skill26;
			temp_population = your.skill21;
			your.skill21 += 0.005;
			your.skill26 += 0.05;				
			if(your.skill21 != temp_population)
			{
				population += your.skill21 - temp_population;
			}
			if(your.skill26 != temp_energy)
			{
				energy += your.skill26 - temp_energy;
			}
		}
 		you = ent_next (you); // get next entity
 			
 	}	
	
}

function at_start()
{
	you = ent_next (NULL); // retrieve first entity
 	while (you != NULL) // repeat until there are no more entities
	{
		if(you ==terran_md_ent && your.skill69 == 1)
	
		{
			population = your.skill21;
			energy = 1000;
		}
 		you = ent_next (you); // get next entity
 			
 	}	
}



 	
function init_gamecounter()
{
	while(player == null){wait(1);}
	var border01;
	var border02;
	var border03;
	var border04;
	
	gameloop = 0;
	init_music();
	init_panels();
	turn_screen.visible = on;
	border01 = screen_size.x -1;
	border02 = screen_size.y -1;
	border03 = border01/2;
	border04 = border02/2;
	draw_red_rect(0,0,border01,border02);
	at_start();
	
	while (gameloop <= 1000)
	{
		while(freeze_mode != 0)
		{
			wait(1);
		}
		
		gameloop += total_secs;
		
	wait(1);
	update_gameloop();
	gameloop = 0;
	}
}
